;masm 6.1
;ml.exe /c envirbug.asm
;link.exe /CPARM:1 envirbug.obj
; SEE LINES 121 - 127 to switch

;;======[ MACRO ]=================================
@Service_near\
	MACRO\
		service_name:req
	;;----------------------------------------
_S@name equ\
		<service_name>
_S@name\
	PROC\
		NEAR PRIVATE
	;;----------------------------------------
	ENDM

;;======[ MACRO ]=================================
@Service_end\
	MACRO
	;;----------------------------------------
	ret
	;;----------------------------------------
_S@name\
	ENDP
	;;----------------------------------------
	ENDM

;;======[ MACRO ]=================================
@Load_ES_DI\
	MACRO\
		variable:req
	;-----------------------------------------
	mov	DI,SEG(variable)
	mov	ES,DI
	lea	DI,variable
	;-----------------------------------------
	ENDM

;=======[ STRUCTURE ]=============================
EPB\
	STRUC
EPB_enviroment_seg\
	WORD	?
EPB_command_tail\
	DWORD	?
EPB1FCB_adress\
	DWORD	?
EPB2FCB_adress\
	DWORD	?
EPB\
        ENDS

	ASSUME\
		CS:PROMPT_BUG,\
		DS:PROMPT_BUG,\
		ES:PROMPT_BUG,\
		SS:PROMPT_BUG_STACK

;=======[ SEGMENT ]===============================
PROMPT_BUG\
	SEGMENT	PARA
;-------------------------------------------------

Start:
	call	Execute
	mov	AH,4Ch
	int	21h

;=======[ SUBROUTINE ]============================
;-------------------------------------------------
; Return:
;-------------------------------------------------
; Parameters:
dos_fn\
	=	4B00h
dos_fn_a\
	=	62h
;
;-------------------------------------------------
@Service_near\
	Execute
	push	DS
	push	ES
	push	BX
	push	SI
	push	DI
	push	DX
	push	AX
	;-----------------------------------------
@Load_ES_DI\
		PP_EPB	
	mov	AH,dos_fn_a
	int	21h
	;-----------------------------------------
	mov	ES:WORD PTR(EPB PTR\
		[DI]).EPB1FCB_adress+2,BX
	mov	ES:WORD PTR(EPB PTR\
		[DI]).EPB2FCB_adress+2,BX
	xor	AX,AX
	mov	ES:(EPB PTR\
		[DI]).EPB_enviroment_seg,AX
	mov	AL,5Ch
	mov	ES:WORD PTR(EPB PTR\
		[DI]).EPB1FCB_adress,AX
	mov	AL,6Ch
	mov	ES:WORD PTR(EPB PTR\
		[DI]).EPB2FCB_adress,AX
	mov	AX,ES
	mov	ES:WORD PTR(EPB PTR\
		[DI]).EPB_command_tail+2,AX
	lea	AX,Tail
	mov	ES:WORD PTR(EPB PTR\
		[DI]).EPB_command_tail,AX
	;-----------------------------------------
	mov	DS,BX
	mov	AX,[SI+2Ch]
	mov	DS,AX
	xor	SI,SI
	;-----------------------------------------
	;Default is 'PROMPT=$P$G',0
	;0 - correct prompt "drive:\path\>"
	;I convert it's case down: 'prompt=$p$g',0
	;1 - error prompt "drive>"
	;-----------------------------------------
	IF	1 ; THIS IS SWITCHER
	lea	DI,prompt_name
_next_1:
	call	String_compare
	mov	AX,7
	cmp	AX,DX
	je	_convert
	call	Measure_string
	or	AX,AX
	jz	_skip
	inc	AX
	add	SI,AX
	jmp\
	short	_next_1
_convert:
	call	Xlat_string_down
_skip:
	ENDIF
	;-----------------------------------------
	xor	SI,SI
	lea	DI,Shell_name
_next_2:
	call	String_compare
	mov	AX,8
	cmp	AX,DX
	je	_launch
	call	Measure_string
	or	AX,AX
	jz	_exit
	inc	AX
	add	SI,AX
	jmp\
	short	_next_2
	;-----------------------------------------
_launch:
	add	DX,SI
	mov	AX,seg(PROMPT_BUG)
	mov	ES,AX
	lea	BX,PP_EPB
	mov	AX,dos_fn
	int	21h
	;-----------------------------------------
_exit:
	pop	AX
	pop	DX
	pop	DI
	pop	SI
	pop	BX
	pop	ES
	pop	DS
@Service_end

;=======[ SUBROUTINE ]============================
; Compare strings
;-------------------------------------------------
; Return:
; AX = 0 if strings equal
; DX = number of congruence symbols
;-------------------------------------------------
; Parameters:
; DS:SI - seg:ofs(string_1)
; ES:DI - seg:ofs(string_2)
;-------------------------------------------------
@Service_near\
	String_compare
	push	SI
	push	DI
	;-----------------------------------------
	xor	DX,DX
_next:
	cld
	cmpsb
	jne	_break
	mov	AL,[SI-1]
	or	AL,AL
	je	_break
	inc	DX
	jmp\
	short	_next
	;-----------------------------------------
_break:
	mov	AL,[SI-1]
	sub	AL,ES:[DI-1]
	cbw
	;-----------------------------------------
_exit:
	pop	DI
	pop	SI
@Service_end

;=======[ SUBROUTINE ]============================
; Mesure string
;-------------------------------------------------
; Return:
; AX = length(string)
;-------------------------------------------------
; Parameters:
; DS:SI - seg:ofs(string)
;-------------------------------------------------
@Service_near\
	Measure_string
	push	BX
	;-----------------------------------------
	cld
	mov	BX,SI
_loop:
	lodsb
	or	AL,AL
	jnz	_loop
	xchg	BX,SI
	mov	AX,BX
	sub	AX,SI
	dec	AX
	;-----------------------------------------
	pop	BX
@Service_end

;=======[ SUBROUTINE ]============================
; Convert string case down
;-------------------------------------------------
; Parameters:
; DS:SI - seg:ofs(string)
;-------------------------------------------------
@Service_near\
	Xlat_string_down
	push	SI
	;-----------------------------------------
	cld
_loop:
	lodsb
	or	AL,AL
	je	_exit
	call	AL_case_down
	mov	[SI-1],AL
	jne	_loop
	;-----------------------------------------
_exit:
	pop	SI
@Service_end

;=======[ SUBROUTINE ]============================
; Convert symbol case down 
;-------------------------------------------------
; Return:
; AL = symbol
;-------------------------------------------------
; Parameters:
; AL - symbol
;-------------------------------------------------
@Service_near\
	AL_case_down
	;-----------------------------------------
	cmp	AL,'A'
	jb	_exit
	cmp	AL,'Z'+1
	cmc
	jb	_exit
	;-----------------------------------------
	add	AL,20h
_exit:
@Service_end

PP_EPB\
	EPB	<>
Prompt_name\
	BYTE	'PROMPT=',0
Shell_name\
	BYTE	'COMSPEC=',0

Tail	LABEL	BYTE
Tail_length\
	BYTE	0
Tail_prefix\
	BYTE	'/c '
Tail_string\
	BYTE	124\
	DUP	(0)
PROMPT_BUG\
	ENDS

;=======[ SEGMENT ]===============================
PROMPT_BUG_STACK\
	SEGMENT PARA STACK 'STACK'
;-------------------------------------------------
	BYTE	1024\
	DUP	(?)
;-------------------------------------------------
PROMPT_BUG_STACK\
	ENDS	

	END	Start